import os,time
 
REFRESH_FLAG_FILE="var/Mott0Refreshing"
TMP_FILE="var/Mott0-tmp"
ALARM_FLAG="var/Mott0-alarm"
CACHE_FILE="var/Mott0CachedIndex.html"
REFRESH_TIMEOUT=1500
ALARM_INTERVAL=3600


MAIL_MESSAGE="""From: Mott0<MotT0-service@cern.ch>
To: %s <%s>
Subject: DAS connection error

MotT0 URL= %s
DAS   URL= %s
""" 
 
def sendAlarm(receiver,DASUrl):
     import cherrypy
     MotT0Port=cherrypy.config['server.socket_port']
     if (existsFile(ALARM_FLAG)):
         if fileOlderThen(ALARM_FLAG, ALARM_INTERVAL):
             removeFile(ALARM_FLAG) 
     if not(existsFile(ALARM_FLAG)):
        import smtplib,socket
        sender = 'MotT0-service@cern.ch'
        #receiver=self.config.emailAlert
        print "Sending mail to: "+str(receiver)
        message = MAIL_MESSAGE
        message=message%(receiver,receiver,"http://"+socket.gethostname()+":"+str(MotT0Port)+"/",DASUrl)
        try:
          smtpObj = smtplib.SMTP('localhost')
          smtpObj.sendmail(sender, receiver, message)  
          print "Successfully sent email"
          setFlag(ALARM_FLAG)
        except Exception:
          print "Error: unable to send email"
#######################################################################
def  workingDAS(DASUrl):
    try:
     from HTTPfetcher import HTTPfetcher
     f=HTTPfetcher(DASUrl+"lastruns")
     data=f.fetchUrl()
     return True
    except:
     return False
##################################################### filesystem opeartions

    
            
            
def fileOlderThen(file, time):
  try:
    statinfo = os.stat(file)
    ftime=  statinfo.st_mtime
    with open(TMP_FILE, 'w') as f:
      f.write("1")
    f.close()
    statinfo = os.stat(TMP_FILE)
    os.remove(TMP_FILE)
    #print "difference file timestamps: %f  timeout=%f on %s"%(statinfo.st_mtime-ftime,time,str(file))
    if statinfo.st_mtime-ftime>=time:
       print "file: "+str(file)+ " older then "+str(time)
       return True
  except: 
     return False
  return False
          
def getCachedPage():
  with open(CACHE_FILE, 'r') as f:
         read_data = f.read()
  f.close()
  return read_data 
    
def existsFile(file):
  try:
    f=open(file, 'r')
    f.close()
    return True
  except:
    return False
    
def saveDataInFile(data,file):
   with open(file, 'w') as f:
        f.write(data)
   f.close()    

def setFlag(file):
  with open(file, 'w') as f:
    f.write("1")
  f.close()
        
                   
def removeFile(file):
    print "Removing file: " +str(file)
    try:
      os.remove(file)
      #print "refrashing flag="+str(self.alreadyRefrashingFlag())
    except:
      print "File not found"
  